
#define N 10
#include <iostream>
#include <cstdlib>
#include <JTC/JTC.h>
#include <ctime>
using namespace std;

class BassoNumero : public JTCMonitor
{
    private:
        int puntate[N];
        bool tuttiHannoPuntato()
        {
            int c=0;
            for(int i=0; i<N; i++)
                if(puntate[i]!=0)
                    c++;
            if (c==N)
                return true;
            return false;
        }
        bool haDuplicati(int j)
        {
            int d=0;
            for(int i=0; i<N; i++)
                if(puntate[i]==puntate[j])
                    d++;
            if (d==1)//incontra se stessa
                return true;
            return false;
        }
    public:
        BassoNumero()
        {
            for(int i=0; i<N; i++)
                puntate[i]=0;
          //  cout<<"Creato BassoNumero "<<endl;
        }
        void punta( int numero, int nGiocatore )
        {
        	JTCSynchronized sync(*this);
        	cout<<"-\n";
        	puntate[nGiocatore]=numero;
            if (tuttiHannoPuntato())
                notify();
            cout<<"*\n";

        }

        int vincitore()
        {
            JTCSynchronized sync(*this);
            if (!tuttiHannoPuntato())
                wait();
            int minValore = 99;//?
            int minIndice = -1;
            for(int i=0; i<N; i++)
                if (puntate[i]<minValore && !haDuplicati(i))
                {
                    minValore = puntate[i];
                    minIndice = i;
                }
            return minIndice;
        }
};

class Giocatore : public JTCThread
{
    public:
        BassoNumero* b;
        int nGiocatore;
        Giocatore(BassoNumero* a, int n)
        {
           // cout<<"In Creazione Giocatore "<<nGiocatore<<endl;
            this->b=a; nGiocatore=n;
           // cout<<"Creato Giocatore "<<nGiocatore<<endl;
        }
        virtual void run()
        {
        	srand(nGiocatore*time(0));
        	b->punta((rand()%10)+1,nGiocatore);
        	//sleep(10000);
        }
};

/*
 * Rispetto al prototipo mostrato a lezione si  deciso di cambiare
 * "Giocatore* gioca()" in "int gioca()". La modifica ha lo scopo di impedire l'accesso
 * alle strutture dati dei thread giocatori, i quali vengono distrutti automaticamente al termine della propria run()
 */

int gioca()
{
    BassoNumero* b = new BassoNumero();
    Giocatore* giocatori[N];
    cout<<"Creo spazio per "<<N<<" Giocatori"<<endl;
    for(int i=0; i<N; i++)
    {
        giocatori[i]=new Giocatore(b,i);
        giocatori[i]->start();
    }
    int v=b->vincitore();
    //int v =0;
    return v;
}

int main()
{
    JTCInitialize init;
	srand(time(0));
    int t = gioca();
    if(t == 0)
        cout << "Nessun Vincitore" << endl;
    else
        cout << "Il Vincitore e' " << t << endl;
    return 0;
}

